////////////////////////////////////////////////////////////////////////////
//
//   soubor:  soucet2.cpp
//   projekt: Sablony v C++ - specializace trochu jinak
//   autor:   Jaroslav Franek
//   (c) 2000 Jaroslav Franek
//
//   Tridy rysu
//      funkce soucet - pokus 2, stale to neni ono
//
////////////////////////////////////////////////////////////////////////////

#pragma hdrstop
#include <condefs.h>
#include <iostream>

template <class VYSLEDEK, class LEVY, class PRAVY>
VYSLEDEK soucet(LEVY levy, PRAVY pravy)
{
   return VYSLEDEK(levy + pravy);
}

//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{
   int a;
   int b = 3;
   short c = 5;

   // tohle neprojde
//   a = soucet(b, c);

   // tohle vsechno znamena totez a je to OK
   a = soucet<int>(b, c);
   std::cout << '\n' << a;

   a = soucet<int, int>(b, c);
   std::cout << '\n' << a;

   a = soucet<int, int, short>(b, c);
   std::cout << '\n' << a;

   // ale stejne tak spravne je
   double d = soucet<double>(b, c);
   std::cout << '\n' << d;

   return 0;
}
